﻿using ProjectWarmlyShip.DrawningObjects;
using ProjectWarmlyShip.Generics;
using ProjectWarmlyShip.MovementStrategy;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Numerics;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectWarmlyShip
{
    /// <summary>
    /// Форма для работы с набором объектов класса DrawningCar
    /// </summary>
    public partial class FormShipCollection : Form
    {
        /// <summary>
        /// Набор объектов
        /// </summary>
        private readonly ShipsGenericCollection<DrawningShip, DrawningObjectShip> _ships;
        /// <summary>
        /// Конструктор
        /// </summary>
        public FormShipCollection()
        {
            InitializeComponent();
            _ships = new ShipsGenericCollection<DrawningShip, DrawningObjectShip>(pictureBoxCollection.Width, pictureBoxCollection.Height);
        }
        /// <summary>
        /// Добавление объекта в набор
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonAddShip_Click(object sender, EventArgs e)
        {
            FormWarmlyShip form = new FormWarmlyShip();
            if (form.ShowDialog() == DialogResult.OK)
            {
                if (_ships + form.SelectedShip != -1)
                {
                    MessageBox.Show("Объект добавлен");
                    pictureBoxCollection.Image = _ships.ShowShips();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }
            }
        }
        /// <summary>
        /// Удаление объекта из набора
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonRemoveShip_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Удалить объект?", "Удаление",
          MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = -1;
            try
            {
                pos = Convert.ToInt32(maskedTextBoxNumber.Text);
            }
            catch (Exception ex) { }
            if (_ships - pos)
            {
                MessageBox.Show("Объект удален");
                pictureBoxCollection.Image = _ships.ShowShips();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }
        }
        /// <summary>
        /// Обновление рисунка по набору
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonRefreshCollection_Click(object sender, EventArgs e)
        {
            pictureBoxCollection.Image = _ships.ShowShips();
        }
    }

}
